2021-07-02 03:31:12

by Lecopzer Chen

[permalink] [raw]
Subject: [PATCH v3 1/2] Kbuild: lto: add CONFIG_MAKE_VERSION

To check the GNU make version. Used by the LTO Kconfig.

LTO with MODVERSIONS will fail in generating correct CRC because
the makefile rule doesn't work for make with version 3.8X.[1]

Thus we need to check make version during selecting on LTO Kconfig.
Add CONFIG_MAKE_VERSION which means MAKE_VERSION in canonical digits
for arithmetic comparisons.

[1] https://lore.kernel.org/lkml/[email protected]/
Signed-off-by: Lecopzer Chen <[email protected]>
---
Makefile | 2 +-
init/Kconfig | 4 ++++
scripts/make-version.sh | 13 +++++++++++++
3 files changed, 18 insertions(+), 1 deletion(-)
create mode 100755 scripts/make-version.sh

diff --git a/Makefile b/Makefile
index 88888fff4c62..2402745b2ba9 100644
--- a/Makefile
+++ b/Makefile
@@ -516,7 +516,7 @@ CLANG_FLAGS :=

export ARCH SRCARCH CONFIG_SHELL BASH HOSTCC KBUILD_HOSTCFLAGS CROSS_COMPILE LD CC
export CPP AR NM STRIP OBJCOPY OBJDUMP READELF PAHOLE RESOLVE_BTFIDS LEX YACC AWK INSTALLKERNEL
-export PERL PYTHON3 CHECK CHECKFLAGS MAKE UTS_MACHINE HOSTCXX
+export PERL PYTHON3 CHECK CHECKFLAGS MAKE MAKE_VERSION UTS_MACHINE HOSTCXX
export KGZIP KBZIP2 KLZOP LZMA LZ4 XZ ZSTD
export KBUILD_HOSTCXXFLAGS KBUILD_HOSTLDFLAGS KBUILD_HOSTLDLIBS LDFLAGS_MODULE

diff --git a/init/Kconfig b/init/Kconfig
index 55f9f7738ebb..ecc110504f87 100644
--- a/init/Kconfig
+++ b/init/Kconfig
@@ -86,6 +86,10 @@ config CC_HAS_ASM_INLINE
config CC_HAS_NO_PROFILE_FN_ATTR
def_bool $(success,echo '__attribute__((no_profile_instrument_function)) int x();' | $(CC) -x c - -c -o /dev/null -Werror)

+config MAKE_VERSION
+ int
+ default $(shell,$(srctree)/scripts/make-version.sh $(MAKE_VERSION))
+
config CONSTRUCTORS
bool

diff --git a/scripts/make-version.sh b/scripts/make-version.sh
new file mode 100755
index 000000000000..3a451db3c067
--- /dev/null
+++ b/scripts/make-version.sh
@@ -0,0 +1,13 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0
+#
+# Print the GNU make version in a 5 or 6-digit form.
+
+set -e
+
+# Convert the version string x.y.z to a canonical 5 or 6-digit form.
+IFS=.
+set -- $1
+
+# If the 2nd or 3rd field is missing, fill it with a zero.
+echo $((10000 * $1 + 100 * ${2:-0} + ${3:-0}))
--
2.18.0


2021-07-04 00:17:52

by Nathan Chancellor

[permalink] [raw]
Subject: Re: [PATCH v3 1/2] Kbuild: lto: add CONFIG_MAKE_VERSION

On Fri, Jul 02, 2021 at 11:29:42AM +0800, Lecopzer Chen wrote:
> To check the GNU make version. Used by the LTO Kconfig.
>
> LTO with MODVERSIONS will fail in generating correct CRC because
> the makefile rule doesn't work for make with version 3.8X.[1]
>
> Thus we need to check make version during selecting on LTO Kconfig.
> Add CONFIG_MAKE_VERSION which means MAKE_VERSION in canonical digits
> for arithmetic comparisons.
>
> [1] https://lore.kernel.org/lkml/[email protected]/
> Signed-off-by: Lecopzer Chen <[email protected]>

Reviewed-by: Nathan Chancellor <[email protected]>

> ---
> Makefile | 2 +-
> init/Kconfig | 4 ++++
> scripts/make-version.sh | 13 +++++++++++++
> 3 files changed, 18 insertions(+), 1 deletion(-)
> create mode 100755 scripts/make-version.sh
>
> diff --git a/Makefile b/Makefile
> index 88888fff4c62..2402745b2ba9 100644
> --- a/Makefile
> +++ b/Makefile
> @@ -516,7 +516,7 @@ CLANG_FLAGS :=
>
> export ARCH SRCARCH CONFIG_SHELL BASH HOSTCC KBUILD_HOSTCFLAGS CROSS_COMPILE LD CC
> export CPP AR NM STRIP OBJCOPY OBJDUMP READELF PAHOLE RESOLVE_BTFIDS LEX YACC AWK INSTALLKERNEL
> -export PERL PYTHON3 CHECK CHECKFLAGS MAKE UTS_MACHINE HOSTCXX
> +export PERL PYTHON3 CHECK CHECKFLAGS MAKE MAKE_VERSION UTS_MACHINE HOSTCXX
> export KGZIP KBZIP2 KLZOP LZMA LZ4 XZ ZSTD
> export KBUILD_HOSTCXXFLAGS KBUILD_HOSTLDFLAGS KBUILD_HOSTLDLIBS LDFLAGS_MODULE
>
> diff --git a/init/Kconfig b/init/Kconfig
> index 55f9f7738ebb..ecc110504f87 100644
> --- a/init/Kconfig
> +++ b/init/Kconfig
> @@ -86,6 +86,10 @@ config CC_HAS_ASM_INLINE
> config CC_HAS_NO_PROFILE_FN_ATTR
> def_bool $(success,echo '__attribute__((no_profile_instrument_function)) int x();' | $(CC) -x c - -c -o /dev/null -Werror)
>
> +config MAKE_VERSION
> + int
> + default $(shell,$(srctree)/scripts/make-version.sh $(MAKE_VERSION))
> +
> config CONSTRUCTORS
> bool
>
> diff --git a/scripts/make-version.sh b/scripts/make-version.sh
> new file mode 100755
> index 000000000000..3a451db3c067
> --- /dev/null
> +++ b/scripts/make-version.sh
> @@ -0,0 +1,13 @@
> +#!/bin/sh
> +# SPDX-License-Identifier: GPL-2.0
> +#
> +# Print the GNU make version in a 5 or 6-digit form.
> +
> +set -e
> +
> +# Convert the version string x.y.z to a canonical 5 or 6-digit form.
> +IFS=.
> +set -- $1
> +
> +# If the 2nd or 3rd field is missing, fill it with a zero.
> +echo $((10000 * $1 + 100 * ${2:-0} + ${3:-0}))
> --
> 2.18.0

2021-07-05 02:04:54

by Masahiro Yamada

[permalink] [raw]
Subject: Re: [PATCH v3 1/2] Kbuild: lto: add CONFIG_MAKE_VERSION

On Fri, Jul 2, 2021 at 12:29 PM Lecopzer Chen
<[email protected]> wrote:
>
> To check the GNU make version. Used by the LTO Kconfig.
>
> LTO with MODVERSIONS will fail in generating correct CRC because
> the makefile rule doesn't work for make with version 3.8X.[1]
>
> Thus we need to check make version during selecting on LTO Kconfig.
> Add CONFIG_MAKE_VERSION which means MAKE_VERSION in canonical digits
> for arithmetic comparisons.
>
> [1] https://lore.kernel.org/lkml/[email protected]/
> Signed-off-by: Lecopzer Chen <[email protected]>
> ---


NACK.

"Let's add MAKE_VERSION >= 40200 restriction
just because I cannot write correct code that
works for older Make" is a horrible idea.

Also, Kconfig is supposed to check the compiler
(or toolchains) capability, not host tool versions.







> Makefile | 2 +-
> init/Kconfig | 4 ++++
> scripts/make-version.sh | 13 +++++++++++++
> 3 files changed, 18 insertions(+), 1 deletion(-)
> create mode 100755 scripts/make-version.sh
>
> diff --git a/Makefile b/Makefile
> index 88888fff4c62..2402745b2ba9 100644
> --- a/Makefile
> +++ b/Makefile
> @@ -516,7 +516,7 @@ CLANG_FLAGS :=
>
> export ARCH SRCARCH CONFIG_SHELL BASH HOSTCC KBUILD_HOSTCFLAGS CROSS_COMPILE LD CC
> export CPP AR NM STRIP OBJCOPY OBJDUMP READELF PAHOLE RESOLVE_BTFIDS LEX YACC AWK INSTALLKERNEL
> -export PERL PYTHON3 CHECK CHECKFLAGS MAKE UTS_MACHINE HOSTCXX
> +export PERL PYTHON3 CHECK CHECKFLAGS MAKE MAKE_VERSION UTS_MACHINE HOSTCXX
> export KGZIP KBZIP2 KLZOP LZMA LZ4 XZ ZSTD
> export KBUILD_HOSTCXXFLAGS KBUILD_HOSTLDFLAGS KBUILD_HOSTLDLIBS LDFLAGS_MODULE
>
> diff --git a/init/Kconfig b/init/Kconfig
> index 55f9f7738ebb..ecc110504f87 100644
> --- a/init/Kconfig
> +++ b/init/Kconfig
> @@ -86,6 +86,10 @@ config CC_HAS_ASM_INLINE
> config CC_HAS_NO_PROFILE_FN_ATTR
> def_bool $(success,echo '__attribute__((no_profile_instrument_function)) int x();' | $(CC) -x c - -c -o /dev/null -Werror)
>
> +config MAKE_VERSION
> + int
> + default $(shell,$(srctree)/scripts/make-version.sh $(MAKE_VERSION))
> +
> config CONSTRUCTORS
> bool
>
> diff --git a/scripts/make-version.sh b/scripts/make-version.sh
> new file mode 100755
> index 000000000000..3a451db3c067
> --- /dev/null
> +++ b/scripts/make-version.sh
> @@ -0,0 +1,13 @@
> +#!/bin/sh
> +# SPDX-License-Identifier: GPL-2.0
> +#
> +# Print the GNU make version in a 5 or 6-digit form.
> +
> +set -e
> +
> +# Convert the version string x.y.z to a canonical 5 or 6-digit form.
> +IFS=.
> +set -- $1
> +
> +# If the 2nd or 3rd field is missing, fill it with a zero.
> +echo $((10000 * $1 + 100 * ${2:-0} + ${3:-0}))
> --
> 2.18.0
>


--
Best Regards
Masahiro Yamada

2021-07-05 18:04:14

by Sami Tolvanen

[permalink] [raw]
Subject: Re: [PATCH v3 1/2] Kbuild: lto: add CONFIG_MAKE_VERSION

On Sun, Jul 4, 2021 at 7:03 PM Masahiro Yamada <[email protected]> wrote:
>
> On Fri, Jul 2, 2021 at 12:29 PM Lecopzer Chen
> <[email protected]> wrote:
> >
> > To check the GNU make version. Used by the LTO Kconfig.
> >
> > LTO with MODVERSIONS will fail in generating correct CRC because
> > the makefile rule doesn't work for make with version 3.8X.[1]
> >
> > Thus we need to check make version during selecting on LTO Kconfig.
> > Add CONFIG_MAKE_VERSION which means MAKE_VERSION in canonical digits
> > for arithmetic comparisons.
> >
> > [1] https://lore.kernel.org/lkml/[email protected]/
> > Signed-off-by: Lecopzer Chen <[email protected]>
> > ---
>
>
> NACK.
>
> "Let's add MAKE_VERSION >= 40200 restriction
> just because I cannot write correct code that
> works for older Make" is a horrible idea.
>
> Also, Kconfig is supposed to check the compiler
> (or toolchains) capability, not host tool versions.

I feel like requiring a Make that's half a decade old for a feature
that also requires a toolchain released last October ago isn't
entirely unreasonable.

That being said, if Masahiro prefers not to rely on the wildcard
function's behavior here, which is a reasonable request, we could
simply use the shell to test for the file's existence:

diff --git a/scripts/Makefile.build b/scripts/Makefile.build
index 34d257653fb4..c6bd62f518ff 100644
--- a/scripts/Makefile.build
+++ b/scripts/Makefile.build
@@ -388,7 +388,7 @@ ifeq ($(CONFIG_LTO_CLANG) $(CONFIG_MODVERSIONS),y y)
cmd_update_lto_symversions = \
rm -f [email protected] \
$(foreach n, $(filter-out FORCE,$^), \
- $(if $(wildcard $(n).symversions), \
+ $(if $(shell test -s $(n).symversions && echo y), \
; cat $(n).symversions >> [email protected]))
else
cmd_update_lto_symversions = echo >/dev/null

This is not quite as efficient as using wildcard, but should work with
older Make versions too. Thoughts?

Sami

2021-07-06 09:08:28

by Lecopzer Chen

[permalink] [raw]
Subject: Re: [PATCH v3 1/2] Kbuild: lto: add CONFIG_MAKE_VERSION

> On Sun, Jul 4, 2021 at 7:03 PM Masahiro Yamada <[email protected]> wrote:
> >
> > On Fri, Jul 2, 2021 at 12:29 PM Lecopzer Chen
> > <[email protected]> wrote:
> > >
> > > To check the GNU make version. Used by the LTO Kconfig.
> > >
> > > LTO with MODVERSIONS will fail in generating correct CRC because
> > > the makefile rule doesn't work for make with version 3.8X.[1]
> > >
> > > Thus we need to check make version during selecting on LTO Kconfig.
> > > Add CONFIG_MAKE_VERSION which means MAKE_VERSION in canonical digits
> > > for arithmetic comparisons.
> > >
> > > [1] https://lore.kernel.org/lkml/[email protected]/
> > > Signed-off-by: Lecopzer Chen <[email protected]>
> > > ---
> >
> >
> > NACK.
> >
> > "Let's add MAKE_VERSION >= 40200 restriction
> > just because I cannot write correct code that
> > works for older Make" is a horrible idea.
> >
> > Also, Kconfig is supposed to check the compiler
> > (or toolchains) capability, not host tool versions.
>
> I feel like requiring a Make that's half a decade old for a feature
> that also requires a toolchain released last October ago isn't
> entirely unreasonable.
>
> That being said, if Masahiro prefers not to rely on the wildcard
> function's behavior here, which is a reasonable request, we could
> simply use the shell to test for the file's existence:
>
> diff --git a/scripts/Makefile.build b/scripts/Makefile.build
> index 34d257653fb4..c6bd62f518ff 100644
> --- a/scripts/Makefile.build
> +++ b/scripts/Makefile.build
> @@ -388,7 +388,7 @@ ifeq ($(CONFIG_LTO_CLANG) $(CONFIG_MODVERSIONS),y y)
> cmd_update_lto_symversions = \
> rm -f [email protected] \
> $(foreach n, $(filter-out FORCE,$^), \
> - $(if $(wildcard $(n).symversions), \
> + $(if $(shell test -s $(n).symversions && echo y), \
> ; cat $(n).symversions >> [email protected]))
> else
> cmd_update_lto_symversions = echo >/dev/null
>
> This is not quite as efficient as using wildcard, but should work with
> older Make versions too. Thoughts?
>


I've tested this in both make-4.3 and 3.81, and the CRC is correct.
But I'm not sure if anyone would have the "arg list too long" issue.

Tested-by: Lecopzer Chen <[email protected]>

2021-07-07 17:03:27

by Sami Tolvanen

[permalink] [raw]
Subject: Re: [PATCH v3 1/2] Kbuild: lto: add CONFIG_MAKE_VERSION

On Tue, Jul 6, 2021 at 2:06 AM Lecopzer Chen <[email protected]> wrote:
>
> > On Sun, Jul 4, 2021 at 7:03 PM Masahiro Yamada <[email protected]> wrote:
> > >
> > > On Fri, Jul 2, 2021 at 12:29 PM Lecopzer Chen
> > > <[email protected]> wrote:
> > > >
> > > > To check the GNU make version. Used by the LTO Kconfig.
> > > >
> > > > LTO with MODVERSIONS will fail in generating correct CRC because
> > > > the makefile rule doesn't work for make with version 3.8X.[1]
> > > >
> > > > Thus we need to check make version during selecting on LTO Kconfig.
> > > > Add CONFIG_MAKE_VERSION which means MAKE_VERSION in canonical digits
> > > > for arithmetic comparisons.
> > > >
> > > > [1] https://lore.kernel.org/lkml/[email protected]/
> > > > Signed-off-by: Lecopzer Chen <[email protected]>
> > > > ---
> > >
> > >
> > > NACK.
> > >
> > > "Let's add MAKE_VERSION >= 40200 restriction
> > > just because I cannot write correct code that
> > > works for older Make" is a horrible idea.
> > >
> > > Also, Kconfig is supposed to check the compiler
> > > (or toolchains) capability, not host tool versions.
> >
> > I feel like requiring a Make that's half a decade old for a feature
> > that also requires a toolchain released last October ago isn't
> > entirely unreasonable.
> >
> > That being said, if Masahiro prefers not to rely on the wildcard
> > function's behavior here, which is a reasonable request, we could
> > simply use the shell to test for the file's existence:
> >
> > diff --git a/scripts/Makefile.build b/scripts/Makefile.build
> > index 34d257653fb4..c6bd62f518ff 100644
> > --- a/scripts/Makefile.build
> > +++ b/scripts/Makefile.build
> > @@ -388,7 +388,7 @@ ifeq ($(CONFIG_LTO_CLANG) $(CONFIG_MODVERSIONS),y y)
> > cmd_update_lto_symversions = \
> > rm -f [email protected] \
> > $(foreach n, $(filter-out FORCE,$^), \
> > - $(if $(wildcard $(n).symversions), \
> > + $(if $(shell test -s $(n).symversions && echo y), \
> > ; cat $(n).symversions >> [email protected]))
> > else
> > cmd_update_lto_symversions = echo >/dev/null
> >
> > This is not quite as efficient as using wildcard, but should work with
> > older Make versions too. Thoughts?
> >
>
>
> I've tested this in both make-4.3 and 3.81, and the CRC is correct.
> But I'm not sure if anyone would have the "arg list too long" issue.
>
> Tested-by: Lecopzer Chen <[email protected]>

Thank you for testing. This should produce a command identical to the
wildcard version (with newer Make versions), so that shouldn't be an
issue. If nobody objects to this approach, would you mind putting this
into a proper patch and sending it as v4?

Sami

2021-07-09 08:25:57

by Lecopzer Chen

[permalink] [raw]
Subject: Re: [PATCH v3 1/2] Kbuild: lto: add CONFIG_MAKE_VERSION

> On Tue, Jul 6, 2021 at 2:06 AM Lecopzer Chen <[email protected]> wrote:
> >
> > > On Sun, Jul 4, 2021 at 7:03 PM Masahiro Yamada <[email protected]> wrote:
> > > >
> > > > On Fri, Jul 2, 2021 at 12:29 PM Lecopzer Chen
> > > > <[email protected]> wrote:
> > > > >
> > > > > To check the GNU make version. Used by the LTO Kconfig.
> > > > >
> > > > > LTO with MODVERSIONS will fail in generating correct CRC because
> > > > > the makefile rule doesn't work for make with version 3.8X.[1]
> > > > >
> > > > > Thus we need to check make version during selecting on LTO Kconfig.
> > > > > Add CONFIG_MAKE_VERSION which means MAKE_VERSION in canonical digits
> > > > > for arithmetic comparisons.
> > > > >
> > > > > [1] https://lore.kernel.org/lkml/[email protected]/
> > > > > Signed-off-by: Lecopzer Chen <[email protected]>
> > > > > ---
> > > >
> > > >
> > > > NACK.
> > > >
> > > > "Let's add MAKE_VERSION >= 40200 restriction
> > > > just because I cannot write correct code that
> > > > works for older Make" is a horrible idea.
> > > >
> > > > Also, Kconfig is supposed to check the compiler
> > > > (or toolchains) capability, not host tool versions.
> > >
> > > I feel like requiring a Make that's half a decade old for a feature
> > > that also requires a toolchain released last October ago isn't
> > > entirely unreasonable.
> > >
> > > That being said, if Masahiro prefers not to rely on the wildcard
> > > function's behavior here, which is a reasonable request, we could
> > > simply use the shell to test for the file's existence:
> > >
> > > diff --git a/scripts/Makefile.build b/scripts/Makefile.build
> > > index 34d257653fb4..c6bd62f518ff 100644
> > > --- a/scripts/Makefile.build
> > > +++ b/scripts/Makefile.build
> > > @@ -388,7 +388,7 @@ ifeq ($(CONFIG_LTO_CLANG) $(CONFIG_MODVERSIONS),y y)
> > > cmd_update_lto_symversions = \
> > > rm -f [email protected] \
> > > $(foreach n, $(filter-out FORCE,$^), \
> > > - $(if $(wildcard $(n).symversions), \
> > > + $(if $(shell test -s $(n).symversions && echo y), \
> > > ; cat $(n).symversions >> [email protected]))
> > > else
> > > cmd_update_lto_symversions = echo >/dev/null
> > >
> > > This is not quite as efficient as using wildcard, but should work with
> > > older Make versions too. Thoughts?
> > >
> >
> >
> > I've tested this in both make-4.3 and 3.81, and the CRC is correct.
> > But I'm not sure if anyone would have the "arg list too long" issue.
> >
> > Tested-by: Lecopzer Chen <[email protected]>
>
> Thank you for testing. This should produce a command identical to the
> wildcard version (with newer Make versions), so that shouldn't be an
> issue. If nobody objects to this approach, would you mind putting this
> into a proper patch and sending it as v4?

Sure, I'll rebase the whole commit and send as v4 soon.